------------------------------------------------------------
-- VHDL IIR_top
-- 2006 1 20 17 45 30
-- Created By "DXP VHDL Generator"
-- "Copyright (c) 2002-2004 Altium Limited"
------------------------------------------------------------

------------------------------------------------------------
-- VHDL IIR_top
------------------------------------------------------------

Library IEEE;
Use     IEEE.std_logic_1164.all;
--synopsys translate_off
library UNISIM;
use unisim.vcomponents.all;
--synopsys translate_on

Entity IIR_top Is
  port
  (
    AD      : In    STD_LOGIC_VECTOR(11 downto 0);           -- ObjectKind=Port|PrimaryId=AD[11..0]
    ADC0    : In    STD_LOGIC_VECTOR(17 downto 0);           -- ObjectKind=Port|PrimaryId=ADC0[17..0]
    ADC0L   : In    STD_LOGIC;                               -- ObjectKind=Port|PrimaryId=ADC0L
    ADC0OVF : Out   STD_LOGIC;                               -- ObjectKind=Port|PrimaryId=ADC0OVF
    CLK     : In    STD_LOGIC;                               -- ObjectKind=Port|PrimaryId=CLK
    CLK1PPS : In    STD_LOGIC;                               -- ObjectKind=Port|PrimaryId=CLK1PPS
    CS      : In    STD_LOGIC;                               -- ObjectKind=Port|PrimaryId=CS
    D       : InOut STD_LOGIC_VECTOR(31 downto 0);           -- ObjectKind=Port|PrimaryId=D[31..0]
    SEL     : In    STD_LOGIC_VECTOR(2 downto 0);            -- ObjectKind=Port|PrimaryId=SEL[2..0]
    WR      : In    STD_LOGIC                                -- ObjectKind=Port|PrimaryId=WR
  );
  attribute MacroCell : boolean;

End IIR_top;
------------------------------------------------------------

------------------------------------------------------------
architecture structure of IIR_top is
   Component ClockCounter                                    -- ObjectKind=Sheet Symbol|PrimaryId=ClockLogic
      port
      (
        A      : out STD_LOGIC_VECTOR(6 downto 0);           -- ObjectKind=Sheet Entry|PrimaryId=ClockCounter.Vhd-A[6..0]
        CLK    : in  STD_LOGIC;                              -- ObjectKind=Sheet Entry|PrimaryId=ClockCounter.Vhd-CLK
        ODD    : out STD_LOGIC;                              -- ObjectKind=Sheet Entry|PrimaryId=ClockCounter.Vhd-ODD
        ONEPPS : in  STD_LOGIC                               -- ObjectKind=Sheet Entry|PrimaryId=ClockCounter.Vhd-ONEPPS
      );
   End Component;

   Component IIR_ADC                                         -- ObjectKind=Sheet Symbol|PrimaryId=ADC
      port
      (
        ADC : in  STD_LOGIC_VECTOR(17 downto 0);             -- ObjectKind=Sheet Entry|PrimaryId=IIR_ADC.Vhd-ADC[17..0]
        L   : in  STD_LOGIC;                                 -- ObjectKind=Sheet Entry|PrimaryId=IIR_ADC.Vhd-L
        O   : out STD_LOGIC_VECTOR(31 downto 0);             -- ObjectKind=Sheet Entry|PrimaryId=IIR_ADC.Vhd-O[31..0]
        OVF : out STD_LOGIC                                  -- ObjectKind=Sheet Entry|PrimaryId=IIR_ADC.Vhd-OVF
      );
   End Component;

   Component IIR_CoeffMem                                    -- ObjectKind=Sheet Symbol|PrimaryId=CoefficientMemory
      port
      (
        A    : in  STD_LOGIC_VECTOR(6 downto 0);             -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-A[6..0]
        ADDR : in  STD_LOGIC_VECTOR(10 downto 0);            -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-ADDR[10..0]
        CLK  : in  STD_LOGIC;                                -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-CLK
        COEF : out STD_LOGIC_VECTOR(17 downto 0);            -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-COEF[17..0]
        CTRL : out STD_LOGIC_VECTOR(17 downto 0);            -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-CTRL[17..0]
        DI   : in  STD_LOGIC_VECTOR(17 downto 0);            -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-DI[17..0]
        DO   : out STD_LOGIC_VECTOR(17 downto 0);            -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-DO[17..0]
        MWE  : in  STD_LOGIC;                                -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-MWE
        SEL  : in  STD_LOGIC_VECTOR(2 downto 0)              -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-SEL[2..0]
      );
   End Component;

   Component IIR_engine                                      -- ObjectKind=Sheet Symbol|PrimaryId=FilterEngine
      port
      (
        C    : in  STD_LOGIC_VECTOR(17 downto 0);            -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-C[17..0]
        CLK  : in  STD_LOGIC;                                -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-CLK
        COEF : in  STD_LOGIC_VECTOR(17 downto 0);            -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-COEF[17..0]
        FIL  : out STD_LOGIC_VECTOR(31 downto 0);            -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-FIL[31..0]
        HT   : in  STD_LOGIC;                                -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-HT
        I    : in  STD_LOGIC_VECTOR(31 downto 0);            -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-I[31..0]
        IOLD : out STD_LOGIC_VECTOR(31 downto 0);            -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-IOLD[31..0]
        IOVF : in  STD_LOGIC;                                -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-IOVF
        OVF  : out STD_LOGIC                                 -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-OVF
      );
   End Component;

   Component IIR_Interface                                   -- ObjectKind=Sheet Symbol|PrimaryId=DataInterface
      port
      (
        AD  : in    STD_LOGIC_VECTOR(11 downto 0);           -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-AD[11..0]
        D   : inout STD_LOGIC_VECTOR(31 downto 0);           -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-D[31..0]
        DA  : in    STD_LOGIC_VECTOR(31 downto 0);           -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-DA[31..0]
        DB  : in    STD_LOGIC_VECTOR(31 downto 0);           -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-DB[31..0]
        EN  : in    STD_LOGIC;                               -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-EN
        MA  : out   STD_LOGIC_VECTOR(10 downto 0);           -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-MA[10..0]
        MI  : in    STD_LOGIC_VECTOR(17 downto 0);           -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-MI[17..0]
        MO  : out   STD_LOGIC_VECTOR(17 downto 0);           -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-MO[17..0]
        MWE : out   STD_LOGIC;                               -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-MWE
        WR  : in    STD_LOGIC                                -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-WR
      );
   End Component;


    Signal PinSignal_ADC_O                  : STD_LOGIC_VECTOR(31 downto 0); -- ObjectKind=Net|PrimaryId=O
    Signal PinSignal_ADC_OVF                : STD_LOGIC; -- ObjectKind=Net|PrimaryId=OVF
    Signal PinSignal_ClockLogic_A           : STD_LOGIC_VECTOR(6 downto 0); -- ObjectKind=Net|PrimaryId=A
    Signal PinSignal_ClockLogic_ODD         : STD_LOGIC; -- ObjectKind=Net|PrimaryId=ODD
    Signal PinSignal_CoefficientMemory_COEF : STD_LOGIC_VECTOR(17 downto 0); -- ObjectKind=Net|PrimaryId=COEF
    Signal PinSignal_CoefficientMemory_CTRL : STD_LOGIC_VECTOR(17 downto 0); -- ObjectKind=Net|PrimaryId=CTRL
    Signal PinSignal_CoefficientMemory_DO   : STD_LOGIC_VECTOR(17 downto 0); -- ObjectKind=Net|PrimaryId=DO
    Signal PinSignal_DataInterface_MA       : STD_LOGIC_VECTOR(10 downto 0); -- ObjectKind=Net|PrimaryId=ADDR
    Signal PinSignal_DataInterface_MO       : STD_LOGIC_VECTOR(17 downto 0); -- ObjectKind=Net|PrimaryId=DI
    Signal PinSignal_DataInterface_MWE      : STD_LOGIC; -- ObjectKind=Net|PrimaryId=MWE
    Signal PinSignal_FilterEngine_FIL       : STD_LOGIC_VECTOR(31 downto 0); -- ObjectKind=Net|PrimaryId=DB
    Signal PinSignal_FilterEngine_IOLD      : STD_LOGIC_VECTOR(31 downto 0); -- ObjectKind=Net|PrimaryId=DA
    Signal PinSignal_FilterEngine_OVF       : STD_LOGIC; -- ObjectKind=Net|PrimaryId=OVF

begin
    FilterEngine : IIR_engine                                -- ObjectKind=Sheet Symbol|PrimaryId=FilterEngine
      Port Map
      (
        C    => PinSignal_CoefficientMemory_CTRL,            -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-C[17..0]
        CLK  => CLK,                                         -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-CLK
        COEF => PinSignal_CoefficientMemory_COEF,            -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-COEF[17..0]
        FIL  => PinSignal_FilterEngine_FIL,                  -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-FIL[31..0]
        HT   => PinSignal_ClockLogic_ODD,                    -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-HT
        I    => PinSignal_ADC_O,                             -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-I[31..0]
        IOLD => PinSignal_FilterEngine_IOLD,                 -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-IOLD[31..0]
        IOVF => PinSignal_ADC_OVF,                           -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-IOVF
        OVF  => PinSignal_FilterEngine_OVF                   -- ObjectKind=Sheet Entry|PrimaryId=IIR_engine.SchDoc-OVF
      );

    DataInterface : IIR_Interface                            -- ObjectKind=Sheet Symbol|PrimaryId=DataInterface
      Port Map
      (
        AD  => AD,                                           -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-AD[11..0]
        D   => D,                                            -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-D[31..0]
        DA  => PinSignal_FilterEngine_IOLD,                  -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-DA[31..0]
        DB  => PinSignal_FilterEngine_FIL,                   -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-DB[31..0]
        EN  => CS,                                           -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-EN
        MA  => PinSignal_DataInterface_MA,                   -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-MA[10..0]
        MI  => PinSignal_CoefficientMemory_DO,               -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-MI[17..0]
        MO  => PinSignal_DataInterface_MO,                   -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-MO[17..0]
        MWE => PinSignal_DataInterface_MWE,                  -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-MWE
        WR  => WR                                            -- ObjectKind=Sheet Entry|PrimaryId=IIR_Interface.Vhd-WR
      );

    CoefficientMemory : IIR_CoeffMem                         -- ObjectKind=Sheet Symbol|PrimaryId=CoefficientMemory
      Port Map
      (
        A    => PinSignal_ClockLogic_A,                      -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-A[6..0]
        ADDR => PinSignal_DataInterface_MA,                  -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-ADDR[10..0]
        CLK  => CLK,                                         -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-CLK
        COEF => PinSignal_CoefficientMemory_COEF,            -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-COEF[17..0]
        CTRL => PinSignal_CoefficientMemory_CTRL,            -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-CTRL[17..0]
        DI   => PinSignal_DataInterface_MO,                  -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-DI[17..0]
        DO   => PinSignal_CoefficientMemory_DO,              -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-DO[17..0]
        MWE  => PinSignal_DataInterface_MWE,                 -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-MWE
        SEL  => SEL                                          -- ObjectKind=Sheet Entry|PrimaryId=IIR_CoeffMem.Vhd-SEL[2..0]
      );

    ClockLogic : ClockCounter                                -- ObjectKind=Sheet Symbol|PrimaryId=ClockLogic
      Port Map
      (
        A      => PinSignal_ClockLogic_A,                    -- ObjectKind=Sheet Entry|PrimaryId=ClockCounter.Vhd-A[6..0]
        CLK    => CLK,                                       -- ObjectKind=Sheet Entry|PrimaryId=ClockCounter.Vhd-CLK
        ODD    => PinSignal_ClockLogic_ODD,                  -- ObjectKind=Sheet Entry|PrimaryId=ClockCounter.Vhd-ODD
        ONEPPS => CLK1PPS                                    -- ObjectKind=Sheet Entry|PrimaryId=ClockCounter.Vhd-ONEPPS
      );

    ADC : IIR_ADC                                            -- ObjectKind=Sheet Symbol|PrimaryId=ADC
      Port Map
      (
        ADC => ADC0,                                         -- ObjectKind=Sheet Entry|PrimaryId=IIR_ADC.Vhd-ADC[17..0]
        L   => ADC0L,                                        -- ObjectKind=Sheet Entry|PrimaryId=IIR_ADC.Vhd-L
        O   => PinSignal_ADC_O,                              -- ObjectKind=Sheet Entry|PrimaryId=IIR_ADC.Vhd-O[31..0]
        OVF => PinSignal_ADC_OVF                             -- ObjectKind=Sheet Entry|PrimaryId=IIR_ADC.Vhd-OVF
      );

    -- Signal Assignments
    ---------------------
    ADC0OVF <= PinSignal_FilterEngine_OVF; -- ObjectKind=Net|PrimaryId=OVF

end structure;
------------------------------------------------------------

