--------------------------------------------------------------------------------
-- SubModule RegOut32
-- Created   4/11/2005 5:39:27 PM
--------------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;

entity RegOut32 is port
   (
     a        : in    std_logic_vector(36 downto 0);
     b        : out   std_logic_vector(31 downto 0);
     CLK      : in    std_logic;
     CE       : in    std_logic;
     IOVF     : in    std_logic;
     OVF      : out   std_logic
   );
end RegOut32;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture RTL of RegOut32 is

   signal overflow : std_logic;

begin
   overflow <= '1' when (a(35) /= a(36)) or (a(34) /= a(36)) or
                        (a(33) /= a(36)) or (a(32) /= a(36)) or
                        (IOVF = '1')
          else '0';
   OVF <= overflow;
   reg: process (CLK, CE, overflow, a) is
   begin
      if rising_edge (CLK) then
         if CE = '1' then
            if overflow = '1' and a(36) = '0' then
               b <= ('0', '0', '0', '0', '0', '0', others => '1');
            elsif overflow = '1' and a(36) = '1' then
               b <= ('1', '1', '1', '1', '1', '1', others => '0');
            else
               b <= a (31 downto 0);
            end if;
         end if;
      end if;
   end process reg;
end architecture RTL;
--------------------------------------------------------------------------------
